import java.util.*;

public class Biblioteca {

	String nome;
	String indirizzo;
	int codice;
	List<Libro> libri;

	// 1- presentare un opportuno costruttore
	public Biblioteca(String nome, String indirizzo, int codice) {
		this.nome = nome;
		this.indirizzo = indirizzo;
		this.codice = codice;
		libri = new ArrayList<Libro>();
	}

	// 2 - presenti opportuni metodi che permettano di accedere alle variabili di
	// istanza delloggetto (non si considerino i libri)
	public String getNome() {
		return nome;
	}

	public String getIndirizzo() {
		return indirizzo;
	}

	public int getCodice() {
		return codice;
	}

	// 3 - possedere un metodo aggiungi che, dato un oggetto Libro,
	// lo aggiunga allinterno della lista mantenendola ordinata secondo il
	// punto 5. dellesercizio precedente
	// (suggerimento: si utilizzi il metodo add(int i, Libro l) della classe List).

	public void aggiungi(Libro l) {
		int i = 0;
		// Determino in che posizione aggiungerlo
		while ((i < libri.size()) && (libri.get(i).compareTo(l) < 0))
			i++;

		// Lo aggiungo in posizione i
		libri.add(i, l);
	}

	// 4 - presentare un metodo cerca che, dato il nome di un autore,
	// restituisca un insieme contenente tutti i libri di tale autore
	// allinterno della sezione.

	public Set<Libro> cerca(String autore) {
		Set<Libro> s = new HashSet<Libro>();
		for (Libro l : libri)
			if (l.getAutore().equals(autore))
				s.add(l);
		return s;
	}

	// 5 - possedere un metodo cancella che, dato il nome di un autore, rimuova
	// dalla biblioteca tutti i libri di tale autore.
	public void cancella(String autore) {
		for (Libro l : libri)
			if (l.getAutore().equals(autore))
				libri.remove(l);
	}

	// 6 - possedere il metodo toString che restituisca una stringa che fornisca una
	// descrizione della biblioteca, compreso il numero di libri effettivamente
	// presenti.
	public String toString() {
		String libridisponibili = "";
		for (Libro l : libri)
			libridisponibili += l.toString() + " ";

		return "Biblioteca " + nome + "(" + codice + ") - " + indirizzo + " con libri " + libridisponibili;
	}

}
