class Libro implements Comparable<Libro> {
	private String autore, titolo, editore;
	private int anno;

	public Libro(String autore, String titolo, String editore, int anno) {
		this.autore = autore;
		this.titolo = titolo;
		this.editore = editore;
		this.anno = anno;
	}

	public String getAutore() {
		return autore;
	}

	public String getTitolo() {
		return titolo;
	}

	public String getEditore() {
		return editore;
	}

	public int getAnno() {
		return anno;
	}

	public String toString() {
		return autore + ": " + titolo + "(" + editore + "); " + anno;
	}

	public boolean equals(Object o) {
		return equals((Libro) o);
	}

	public boolean equals(Libro l) {
		return ((autore.equals(l.autore)) && (titolo.equals(l.titolo)));
	}

	public int compareTo(Libro l) {
		int ret = this.autore.compareTo(l.autore);
		if (ret == 0)
			ret = this.anno - l.anno;
		return ret;
	}
}